summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Steven Voges <svoges.sbo@gmail.com>2022-09-24 21:05:15 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2022-09-25 13:59:46 +0700
commit52fd803df4120442e312be365e560124cb9ed6c0 (patch)
tree07b99e897b946d5b5e36ea37ea5820c911863a45
parent2ad9766717e60142483a496cec082762b1628289 (diff)
downloadslackbuilds-52fd803df4120442e312be365e560124cb9ed6c0.tar.gz
slackbuilds-52fd803df4120442e312be365e560124cb9ed6c0.tar.xz
libraries/zydis: Added (x86/x64 Disassembler)
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/zydis/README15
-rw-r--r--libraries/zydis/slack-desc19
-rw-r--r--libraries/zydis/zydis.SlackBuild109
-rw-r--r--libraries/zydis/zydis.info12
4 files changed, 155 insertions, 0 deletions
diff --git a/libraries/zydis/README b/libraries/zydis/README
new file mode 100644
index 0000000000..7c7bedf1f4
--- /dev/null
+++ b/libraries/zydis/README
@@ -0,0 +1,15 @@
+Fast and lightweight x86/x86-64 disassembler and code generation
+library.
+
+Features
+ * Supports all x86 and x86-64 (AMD64) instructions and extensions
+ * Optimized for high performance
+ * No dynamic memory allocation ("malloc")
+ * Thread-safe by design
+ * Very small file-size overhead compared to other common
+ disassembler libraries
+ * Complete doxygen documentation
+ * Absolutely no third party dependencies — not even libc
+ - Should compile on any platform with a working C11 compiler
+ - Tested on Windows, macOS, FreeBSD, Linux and UEFI, both user
+ and kernel mode
diff --git a/libraries/zydis/slack-desc b/libraries/zydis/slack-desc
new file mode 100644
index 0000000000..5430505d37
--- /dev/null
+++ b/libraries/zydis/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+zydis: zydis (x86/x64 Disassembler)
+zydis:
+zydis: Fast and lightweight x86/x86-64 disassembler and code generation
+zydis: library.
+zydis:
+zydis: Homepage: https://zydis.re
+zydis:
+zydis:
+zydis:
+zydis:
+zydis:
diff --git a/libraries/zydis/zydis.SlackBuild b/libraries/zydis/zydis.SlackBuild
new file mode 100644
index 0000000000..97cab9c2a6
--- /dev/null
+++ b/libraries/zydis/zydis.SlackBuild
@@ -0,0 +1,109 @@
+#!/bin/bash
+
+# Slackware build script for zydis
+
+# Copyright 2022 Steven Voges <Oregon, USA>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=zydis
+VERSION=${VERSION:-3.2.1}
+ZYCOREC=${ZYCOREC:-6c93d9a38e62d4db82f99bf99159e1ee78341e36}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+DEPS=$TMP/$PRGNAM-$VERSION/dependencies
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+tar xvf $CWD/zycore-c-$ZYCOREC.tar.gz -C \
+ $DEPS/zycore --strip-components 1
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DZYDIS_BUILD_EXAMPLES=OFF \
+ -DZYDIS_BUILD_SHARED_LIB=ON \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/zydis/zydis.info b/libraries/zydis/zydis.info
new file mode 100644
index 0000000000..f044637de0
--- /dev/null
+++ b/libraries/zydis/zydis.info
@@ -0,0 +1,12 @@
+PRGNAM="zydis"
+VERSION="3.2.1"
+HOMEPAGE="https://zydis.re"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://github.com/zyantific/zydis/archive/v3.2.1/zydis-3.2.1.tar.gz \
+ https://github.com/zyantific/zycore-c/archive/6c93d9a38e62d4db82f99bf99159e1ee78341e36/zycore-c-6c93d9a38e62d4db82f99bf99159e1ee78341e36.tar.gz"
+MD5SUM_x86_64="b7a3e79552cd11f87f7fbe7ff1e0c814 \
+ 30a4aa13d9192b08ed0fb18e562bc293"
+REQUIRES=""
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"